"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular-devkit/core");
const schematics_1 = require("@angular-devkit/schematics");
const utils_1 = require("../utils");
const path_1 = require("path");
const parse_name_1 = require("@schematics/angular/utility/parse-name");
const validation_1 = require("@schematics/angular/utility/validation");
const workspace_1 = require("@schematics/angular/utility/workspace");
const format = require("string-template");
function buildSelector(options, projectPrefix) {
    let selector = core_1.strings.dasherize(options.name);
    if (options.prefix) {
        selector = `${options.prefix}-${selector}`;
    }
    else if (options.prefix === undefined && projectPrefix) {
        selector = `${projectPrefix}-${selector}`;
    }
    return selector;
}
function addHostCssVariable(options) {
    return (host) => __awaiter(this, void 0, void 0, function* () {
        const workspace = yield workspace_1.getWorkspace(host);
        const project = workspace.projects.get(options.project);
        if (options.path === undefined && project) {
            options.path = workspace_1.buildDefaultPath(project);
        }
        const parsedPath = parse_name_1.parseName(options.path, options.name);
        options.name = parsedPath.name;
        options.path = parsedPath.path;
        options.selector = options.selector || buildSelector(options, project && project.prefix || '');
        validation_1.validateName(options.name);
        validation_1.validateHtmlSelector(options.selector);
        const stylePath = path_1.join(options.path, core_1.strings.dasherize(options.name), `${core_1.strings.dasherize(options.name)}.${options.type}.${options.style}`);
        const HEADER = format(options.styleHeader, {
            name: core_1.strings.dasherize(options.name)
        });
        return schematics_1.chain([
            (host) => {
                return utils_1.saveFile(host, stylePath, (src) => {
                    return HEADER + `${src}`;
                });
            }
        ]);
    });
}
exports.addHostCssVariable = addHostCssVariable;
function default_1(options) {
    return (host, context) => {
        return schematics_1.chain([
            schematics_1.externalSchematic('@schematics/angular', 'component', Object.assign({}, options)),
            addHostCssVariable(Object.assign({}, options)),
        ]);
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map