"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tasks_1 = require("@angular-devkit/schematics/tasks");
const utils_1 = require("../utils");
function index(options) {
    return (host, context) => {
        const ngCoreVersionTag = utils_1.getPackageVersionFromPackageJson(host, '@angular/core');
        const angularDependencyVersion = ngCoreVersionTag || `0.0.0-NG`;
        if (angularDependencyVersion === '0.0.0-NG') {
            throw new Error('@angular/core version is not supported.');
        }
        utils_1.addPackageToPackageJson(host, 'angular-host-css-variable', getCustomWebpackVersion(angularDependencyVersion), 'devDependencies');
        utils_1.addPackageToPackageJson(host, 'angular-custom-webpack-chaining', getCustomWebpackVersion(angularDependencyVersion), 'devDependencies');
        context.addTask(new tasks_1.NodePackageInstallTask());
        utils_1.addStyleIncludePathToAngularJson(host, options.project, 'node_modules/host-css-variable');
        const packageName = 'angular-host-css-variable';
        const collection = `${packageName}`;
        utils_1.setDefaultCollectionToAngularJson(host, collection);
        context.addTask(new tasks_1.RunSchematicTask('angular-custom-webpack-chaining', 'ng-add', { project: options.project }));
        context.addTask(new tasks_1.RunSchematicTask('angular-custom-webpack-chaining', 'add-chain', {
            project: options.project,
            path: 'node_modules/angular-host-css-variable',
            architect: 'build'
        }));
        return host;
    };
}
exports.index = index;
function getCustomWebpackVersion(ver) {
    const [major, minor, patch] = (ver.replace(/(\^|\~)/, '')).split('.');
    switch (major) {
        case '10': return '^0.1000.0';
        case '11': return '^0.1100.0';
        default: throw new Error('@angular/core version is not supported.');
    }
}
exports.getCustomWebpackVersion = getCustomWebpackVersion;
//# sourceMappingURL=index.js.map